version: "3.9"

networks:
  default:
    name: ${DEMI_NET}
    external: true

services:
  api:
    build:
      context: .
      dockerfile: api/Dockerfile
    image: ${API_IMAGE}
    command: itk-demo-template
    ports:
      - "5000:5000"
    labels:
      - ${DEMI_NAMESPACE}.api

  worker:
    image: ${API_IMAGE}
    command: /bin/bash --login -c itk-demo-template
    depends_on:
      - api
      - rabbitmq
      - redis
    labels:
      - ${DEMI_NAMESPACE}.worker

  # beat:
  #   image: itk-demo-template
  #   command: /bin/bash --login -c "bin/run_beat.sh -s /home/demi/celerybeat-schedule"
  #   environment:
  #     - CELERY_BROKER_URL=redis://redis/0
  #     - CELERY_RESULT_BACKEND=redis://redis/0
  #   volumes:
  #     - ${PPWD}/docker:/home/demi/celerybeat-schedule
  #   depends_on:
  #     - redis

  redis:
    image: docker.io/redis:alpine
    ports:
      - 6379:6379
    labels:
      - ${DEMI_NAMESPACE}.redis.tcp.uri=redis:6379

  rabbitmq:
    image: docker.io/rabbitmq:3-management
    # hostname: rabbitmq
    # container_name: "broker"
    ports:
      - 15672:15672
      - 5672:5672
    labels:
      - ${DEMI_NAMESPACE}.rabbitmq.amqp.uri=${HOST}:5672
      - ${DEMI_NAMESPACE}.rabbitmq.ui.uri=${HOST}:15672
      - ${DEMI_NAMESPACE}.rabbitmq.api.uri=${HOST}:15672/api

  flower:
    image: ${API_IMAGE}
    command: /bin/bash --login -c "bin/run_flower.sh"
    ports:
      - :5555
    depends_on:
      - worker
    labels:
      - ${DEMI_NAMESPACE}.flower.ui.uri=http://${HOST}:5555
      - ${DEMI_NAMESPACE}.flower.api.uri=http://${HOST}:5555/api

  prometheus:
    image: docker.io/prom/prometheus
    depends_on:
      - flower
    volumes:
      - ${DOCKER_DIR}/prometheus/prometheus.yml:/etc/prometheus/prometheus.yml
    ports:
      - :9090

  grafana:
    image: docker.io/grafana/grafana
    user: ${PUID}:${PGID}
    depends_on:
      - prometheus
    volumes:
      - ${DOCKER_DIR}/grafana:/var/lib/grafana
    ports:
      - 3000:3000

  # see https://github.com/joeferner/redis-commander/blob/423e7d6/docker-compose.yml
  redis-commander:
    # restart: unless-stopped
    image: docker.io/rediscommander/redis-commander:latest
    # container_name: redis-commander
    depends_on:
      - redis
    environment:
      - REDIS_HOSTS=local:redis:6379
      # - URL_PREFIX=/redis
    ports:
      - :8081
    labels:
      # - "traefik.enable=true"
      # - "traefik.http.routers.rediscommander.rule=PathPrefix(`/redis`)"
      # - "traefik.http.routers.rediscommander.entrypoints=http"
      # - "traefik.http.services.rediscommander.loadbalancer.server.port=8081"
      - ${DEMI_NAMESPACE}.redis-commander
  # worker:
  #   build: ./
  #   entrypoint: celery
  #   command: -A tasks worker -l info -E
  #   user: nobody
  #   volumes:
  #     - ./examples:/data
  #   environment:
  #     CELERY_BROKER_URL: redis://redis
  #     CELERY_RESULT_BACKEND: redis://redis
  #     PYTHONPATH: /data
  #   depends_on:
  #     - redis

  # flower:
  #   image: mher/flower:latest
  #   command: celery flower
  #   # command: celery -A itk_demo_template flower
  #   # volumes:
  #   #   - ./examples:/data
  #   working_dir: /data
  #   ports:
  #     - 5555:5555
  #   environment:
  #     CELERY_BROKER_URL: redis://redis
  #     CELERY_RESULT_BACKEND: redis://redis
  #   depends_on:
  #     - redis
  #     - worker
  #   networks:
  #     - demi
